            #GIT_CMT=607b4fa4de48ddb132b3dfac7a009863e6b435a9
%define pname oracle-database-preinstall
%define dbrel 19c
%define configdir /etc/sysconfig
%define logdir /var/log
%define version 1.0
%define release 3%{?dist}
%define name %{pname}-%{dbrel}
%global debug_package %{nil}

Summary: Oracle Database Preinstallation RPM
Name: %{name}
Version: %{version}
Release:    3.el7
License: GPLv2
Vendor: Oracle
Source: oracle-database-preinstall-1.0.tar.bz2
Provides: %{name} = %{version}

Conflicts: exadata-base
Requires(pre): /etc/redhat-release 
Requires: procps module-init-tools ethtool initscripts bind-utils nfs-utils util-linux-ng pam 
Requires: xorg-x11-utils xorg-x11-xauth smartmontools 
Requires: binutils glibc glibc-devel 
Requires: ksh libaio libaio-devel libgcc libstdc++ libstdc++-devel 
Requires: make sysstat openssh-clients 
Requires: psmisc net-tools unzip bc tar 
%if 0%{?el7} 
Requires: compat-libcap1 
%endif 
%if 0%{?el8} 
Requires: libnsl compat-openssl10 
%endif  

BuildRequires: bash
BuildRoot: %{_builddir}/%{pname}-%{version}-root

%description
The Oracle Database Preinstallation RPM automatically installs any additional
packages needed for installing Oracle Grid Infrastructure and Oracle Database
and configures your server operating system automatically, including setting
kernel parameters and other basic operating system requirements for install.

%prep
%setup -q -n %{pname}-%{version}

%build

%install 
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/bin
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/security/limits.d
mkdir -p -m 755 $RPM_BUILD_ROOT/%{configdir}/%{name}
mkdir -p -m 700 $RPM_BUILD_ROOT/%{logdir}/%{name}/results
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-verify
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
install -m 600 %{pname}.param $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
install -m 700 %{pname}-firstboot $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
touch $RPM_BUILD_ROOT/etc/security/limits.d/%{name}.conf
ln -f -s %{configdir}/%{name}/%{name}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param

%clean 
rm -rf $RPM_BUILD_ROOT

%define prescript()  \
if [ -f %{configdir}/%{pname}-%1/%{pname}-%1.param ]; then  \
  cp -f %{configdir}/%{pname}-%1/%{pname}-%1.param %{logdir}/%{pname}-%1/results/.%{pname}-%1.param; \
fi; \
if [ -d %{configdir}/%{pname}-%1 ]; then \
  rm -rf %{configdir}/%{pname}-%1; \
fi;

%define preunscript()  \
if [ "$1" = "0" ] ; then \
 chkconfig --del %{pname}-%1-firstboot; \
 if [ -x /usr/bin/%{pname}-%1-verify ]; then \
   /usr/bin/%{pname}-%1-verify -u 2> /dev/null 1>&2; \
 fi; \
fi;

%define posttransscript()  \
/usr/bin/%{pname}-%1-verify 2>/dev/null 1>&2; \
if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
       chkconfig --add %{pname}-%1-firstboot; \
fi;

%define postunscript()  \
if [ "$1" = "0" ] ; then \
 if [ -d %{configdir}/%{pname}-%1 ]; then \
   rm -rf %{configdir}/%{pname}-%1; \
 fi; \
 if [ -d %{logdir}/%{pname}-%1 ]; then  \
   rm -rf %{logdir}/%{pname}-%1; \
 fi; \
fi;

%pre
%{expand:%%prescript %{dbrel}}

%preun
%{expand:%%preunscript %{dbrel}}

%posttrans
%{expand:%%posttransscript %{dbrel}}

%postun
%{expand:%%postunscript %{dbrel}}

%files
%defattr(-,root,root)
%license LICENSE
%config %{configdir}/%{name}/%{name}.param
%ghost /etc/security/limits.d/%{name}.conf
%{configdir}/%{name}
/etc/rc.d/init.d/%{name}-firstboot
%{configdir}/%{name}/%{name}-verify
%{logdir}/%{name}
/usr/bin/%{name}-verify

%changelog
* Mon Mar 29 2021  Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-3.el7]
- BUILDINFO: commit=607b4fa4de48ddb132b3dfac7a009863e6b435a9
 - Added LICENSE file and modified description [Orabug: 32694386]

* Wed Aug 26 2020  Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.4.el7]
 - Set default to current kernel when saved_entry is not present [Orabug: 31618163]

* Thu Aug 6 2020  Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.3.el7]
 - Set proper default kernel while running grub2-mkconfig [Orabug: 31618334]

* Tue Jun 9 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.2.el7]
 - Update boot options when grubby is used with blscfg [Orabug: 31466178]

* Tue Jun 2 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.1.el7]
 - Do not turn numa off on a Superdome system [Orabug: 31318578]

* Tue Mar 10 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-2.el7]
 - Fix %pre script for dbrel 
 - Revert to chkconfig

* Mon Mar 9 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.6.el7]
 - Remove compat-libstdc++ from dependencies [Orabug: 30958861]
 - Include ulimit -d [Orabug: 30407482]
 - Replaced chkconfig with systemctl in the spec
 - Removed check for el6 in the spec as it is not supported for 19c

* Tue Feb 11 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.5.el7]
 - Do not install on an EXADATA system [Orabug: 30846947]

* Mon Jul 29 2019 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.4.el7]
 - Look for exact match in /etc/group [Orabug: 30106011]
 - Fix for picking the next available uid/gid [Orabug: 30108093]
 - Spec made modular 
 - Code moved to git

* Tue Dec 4 2018  Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.el7]
 - Initial version
